import * as cdk from "@aws-cdk/core";
import * as rds from "@aws-cdk/aws-rds";
import * as ec2 from "@aws-cdk/aws-ec2";
declare type DatabaseCapacity = 1 | 2 | 4 | 8 | 16 | 32 | 64 | 128 | 192 | 256 | 384;
/**
 * @experimental
 */
export interface DatabaseProps {
    /**
     * @experimental
     */
    readonly engine: "mysql" | "postgres";
    /**
     * @experimental
     */
    readonly databaseName?: string;
    /**
     * @experimental
     */
    readonly username?: string;
    /**
     * @experimental
     */
    readonly vpc?: ec2.IVpc;
    /**
     * @experimental
     */
    readonly autoPause?: number;
    /**
     * @experimental
     */
    readonly minCapacity?: DatabaseCapacity;
    /**
     * @experimental
     */
    readonly maxCapacity?: DatabaseCapacity;
}
/**
 * @experimental
 */
export interface DatabaseVariables {
    /**
     * @experimental
     */
    readonly databaseUrl: string;
    /**
     * @experimental
     */
    readonly databaseName: string;
    /**
     * @experimental
     */
    readonly databaseUsername: string;
    /**
     * @experimental
     */
    readonly databasePassword: string;
    /**
     * @experimental
     */
    readonly databaseHost: string;
    /**
     * @experimental
     */
    readonly databasePort: string;
    /**
     * @experimental
     */
    readonly databaseType: string;
}
/**
 * @experimental
 * @order 5
 */
export declare class Database extends cdk.Construct {
    /**
     * @experimental
     */
    cluster: rds.IServerlessCluster;
    /**
     * @experimental
     */
    env: DatabaseVariables;
    /**
     * @param scope the scope.
     * @param id the id.
     * @param props the props.
     * @experimental
     */
    constructor(scope: cdk.Construct, id: string, props: DatabaseProps);
    private getCapacity;
}
export {};
