import * as cdk from "@aws-cdk/core";
import * as route53 from "@aws-cdk/aws-route53";
import * as certificatemanager from "@aws-cdk/aws-certificatemanager";
/**
 * @experimental
 */
export interface DomainProps {
    /**
     * @experimental
     */
    readonly name: string;
    /**
     * @experimental
     */
    readonly certificate?: boolean;
}
/**
 * @experimental
 */
export interface MxRecordProps {
    /**
     * @experimental
     */
    readonly ttl?: number;
    /**
     * @experimental
     */
    readonly values: route53.MxRecordValue[];
}
/**
 * @experimental
 */
export interface CNameRecordProps {
    /**
     * @experimental
     */
    readonly ttl?: number;
    /**
     * @experimental
     */
    readonly name: string;
    /**
     * @experimental
     */
    readonly target: string;
}
/**
 * @experimental
 */
export interface ARecordProps {
    /**
     * @experimental
     */
    readonly ttl?: number;
    /**
     * @experimental
     */
    readonly name: string;
    /**
     * @experimental
     */
    readonly targetIP: string;
}
/**
 * @experimental
 */
export interface AaaaRecordProps extends ARecordProps {
}
/**
 * @experimental
 */
export interface TxtRecordProps {
    /**
     * @experimental
     */
    readonly ttl?: number;
    /**
     * @experimental
     */
    readonly name: string;
    /**
     * @experimental
     */
    readonly values: string[];
}
/**
 * @experimental
 * @order 6
 */
export declare class Domain extends cdk.Construct {
    /**
     * @experimental
     */
    hostedZone: route53.IHostedZone;
    /**
     * @experimental
     */
    certificate?: certificatemanager.ICertificate;
    /**
     * @param scope The parent of this resource, for example a ``{@link "app#stacks" | Stack}``.
     * @experimental
     */
    constructor(scope: cdk.Construct, id: string, props: DomainProps);
    /**
     * @experimental
     */
    addMxRecords(id: string, props: MxRecordProps): void;
    /**
     * @experimental
     */
    addCnameRecord(id: string, props: CNameRecordProps): void;
    /**
     * @experimental
     */
    addARecord(id: string, props: ARecordProps): void;
    /**
     * @experimental
     */
    addAaaaRecord(id: string, props: ARecordProps): void;
    /**
     * @experimental
     */
    addTxtRecord(id: string, props: TxtRecordProps): void;
}
