import * as cdk from "@aws-cdk/core";
import * as pipelines from "@aws-cdk/pipelines";
import { RepositoryHost } from "./types";
/**
 * @experimental
 */
export interface PipelineStackProps extends cdk.StackProps {
    /**
     * @experimental
     */
    readonly appName: string;
    /**
     * @experimental
     */
    readonly repositoryTokenSecretName: string;
    /**
     * @experimental
     */
    readonly host: RepositoryHost;
    /**
     * @experimental
     */
    readonly owner: string;
    /**
     * @experimental
     */
    readonly repo: string;
    /**
     * @experimental
     */
    readonly branch: string;
}
/**
 * @experimental
 * @ignore true
 */
export declare class PipelineStack extends cdk.Stack {
    /**
     * @experimental
     */
    pipeline: pipelines.CdkPipeline;
    /**
     * @experimental
     */
    constructor(scope: cdk.Construct, id: string, props: PipelineStackProps);
    private getSourceAction;
    private getLanguage;
    private getPipelineCommands;
}
