import * as cdk from "@aws-cdk/core";
import * as route53 from "@aws-cdk/aws-route53";
import * as certificatemanager from "@aws-cdk/aws-certificatemanager";
import * as rds from "@aws-cdk/aws-rds";
/**
 * @experimental
 */
export interface RefParameterProps {
    /**
     * @experimental
     */
    readonly appName?: string;
    /**
     * @experimental
     */
    readonly name?: string;
}
/**
 * @experimental
 */
export declare class Ref extends cdk.Construct {
    private constructor();
    /**
     * @experimental
     */
    static addHostedZone(scope: cdk.Construct, id: string, hostedZone: route53.IHostedZone, props?: RefParameterProps): void;
    /**
     * @experimental
     */
    static getHostedZone(scope: cdk.Construct, id: string, props?: RefParameterProps): route53.IHostedZone;
    /**
     * @experimental
     */
    static addCertificate(scope: cdk.Construct, id: string, certificate: certificatemanager.ICertificate, props?: RefParameterProps): void;
    /**
     * @experimental
     */
    static getCertificate(scope: cdk.Construct, id: string, props?: RefParameterProps): certificatemanager.ICertificate;
    /**
     * @experimental
     */
    static addServerlessCluster(scope: cdk.Construct, id: string, serverlessCluster: rds.IServerlessCluster, props?: RefParameterProps): void;
    /**
     * @experimental
     */
    static getServerlessCluster(scope: cdk.Construct, id: string, props?: RefParameterProps): rds.IServerlessCluster;
}
